/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CampaignStrategy type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignStrategy{}

// CampaignStrategy struct for CampaignStrategy
type CampaignStrategy struct {
	ComChannel *CampaignStrategyComChannel `json:"com_channel,omitempty"`
	Channel *CampaignStrategyChannel `json:"channel,omitempty"`
	Type *string `json:"type,omitempty"`
}

// NewCampaignStrategy instantiates a new CampaignStrategy object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignStrategy() *CampaignStrategy {
	this := CampaignStrategy{}
	return &this
}

// NewCampaignStrategyWithDefaults instantiates a new CampaignStrategy object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignStrategyWithDefaults() *CampaignStrategy {
	this := CampaignStrategy{}
	return &this
}

// GetComChannel returns the ComChannel field value if set, zero value otherwise.
func (o *CampaignStrategy) GetComChannel() CampaignStrategyComChannel {
	if o == nil || IsNil(o.ComChannel) {
		var ret CampaignStrategyComChannel
		return ret
	}
	return *o.ComChannel
}

// GetComChannelOk returns a tuple with the ComChannel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignStrategy) GetComChannelOk() (*CampaignStrategyComChannel, bool) {
	if o == nil || IsNil(o.ComChannel) {
		return nil, false
	}
	return o.ComChannel, true
}

// HasComChannel returns a boolean if a field has been set.
func (o *CampaignStrategy) HasComChannel() bool {
	if o != nil && !IsNil(o.ComChannel) {
		return true
	}

	return false
}

// SetComChannel gets a reference to the given CampaignStrategyComChannel and assigns it to the ComChannel field.
func (o *CampaignStrategy) SetComChannel(v CampaignStrategyComChannel) {
	o.ComChannel = &v
}

// GetChannel returns the Channel field value if set, zero value otherwise.
func (o *CampaignStrategy) GetChannel() CampaignStrategyChannel {
	if o == nil || IsNil(o.Channel) {
		var ret CampaignStrategyChannel
		return ret
	}
	return *o.Channel
}

// GetChannelOk returns a tuple with the Channel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignStrategy) GetChannelOk() (*CampaignStrategyChannel, bool) {
	if o == nil || IsNil(o.Channel) {
		return nil, false
	}
	return o.Channel, true
}

// HasChannel returns a boolean if a field has been set.
func (o *CampaignStrategy) HasChannel() bool {
	if o != nil && !IsNil(o.Channel) {
		return true
	}

	return false
}

// SetChannel gets a reference to the given CampaignStrategyChannel and assigns it to the Channel field.
func (o *CampaignStrategy) SetChannel(v CampaignStrategyChannel) {
	o.Channel = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *CampaignStrategy) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignStrategy) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *CampaignStrategy) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *CampaignStrategy) SetType(v string) {
	o.Type = &v
}

func (o CampaignStrategy) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignStrategy) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ComChannel) {
		toSerialize["com_channel"] = o.ComChannel
	}
	if !IsNil(o.Channel) {
		toSerialize["channel"] = o.Channel
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	return toSerialize, nil
}

type NullableCampaignStrategy struct {
	value *CampaignStrategy
	isSet bool
}

func (v NullableCampaignStrategy) Get() *CampaignStrategy {
	return v.value
}

func (v *NullableCampaignStrategy) Set(val *CampaignStrategy) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignStrategy) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignStrategy) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignStrategy(val *CampaignStrategy) *NullableCampaignStrategy {
	return &NullableCampaignStrategy{value: val, isSet: true}
}

func (v NullableCampaignStrategy) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignStrategy) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


